package com.steerinfo.pretrack.pretracktementrust.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.pretrack.pretracktementrust.model.PreTrackTemEntrust;
import com.steerinfo.pretrack.pretracktementrust.service.IPreTrackTemEntrustService;
import com.steerinfo.util.CommonPage;
import com.steerinfo.util.FieldsCollector;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.*;

/**
 * PreTrackTemEntrust RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2021-06-02 09:52
 * 类描述
 * 修订历史：
 * 日期：2021-06-02
 * 作者：generator
 * 参考：
 * 描述：PreTrackTemEntrust RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/pretracktementrusts")
public class PreTrackTemEntrustController extends BaseRESTfulController {

    @Autowired
    IPreTrackTemEntrustService preTrackTemEntrustService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("pretracktementrust:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<PreTrackTemEntrust> list = preTrackTemEntrustService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("pretracktementrust:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<PreTrackTemEntrust> list = preTrackTemEntrustService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据PreTrackTemEntrust对象创建")
    @ApiImplicitParam(name = "preTrackTemEntrust", value = "详细实体preTrackTemEntrust", required = true, dataType = "PreTrackTemEntrust")
    //@RequiresPermissions("pretracktementrust:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute PreTrackTemEntrust model) {
        try {
            PreTrackTemEntrust preTrackTemEntrust = preTrackTemEntrustService.add(model);
            return success(preTrackTemEntrust);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("pretracktementrust:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            PreTrackTemEntrust preTrackTemEntrust = preTrackTemEntrustService.getById(id);
            return success(preTrackTemEntrust);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的preTrackTemEntrust信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "preTrackTemEntrust", value = "详细实体preTrackTemEntrust", required = true, dataType = "PreTrackTemEntrust")
    })
    //@RequiresPermissions("pretracktementrust:update")
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody PreTrackTemEntrust model) {
        try {
            model.setId(id);
            PreTrackTemEntrust preTrackTemEntrust = preTrackTemEntrustService.modify(model);
            return success(preTrackTemEntrust);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("pretracktementrust:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id) {
        try {
            List<String> list = Arrays.asList(id.split(","));
            if (ListUtils.isNotEmpty(list)) {
                List<String> ids = ListUtils.convertList(list);
                preTrackTemEntrustService.delete(ids);
            }
            return success();
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }


    @ApiOperation(value = "插入数据", notes = "根据PreTrackTemEntrust对象创建")
    @ApiImplicitParam(name = "preTrackTemEntrust", value = "详细实体preTrackTemEntrust", required = true, dataType = "PreTrackTemEntrust")
    //@RequiresPermissions("pretracktementrust:create")
    @PostMapping(value = "/add")
    public RESTfulResult insert(@RequestBody PreTrackTemEntrust model) {
        try {
            PreTrackTemEntrust preTrackTemEntrust = preTrackTemEntrustService.insert(model);
            return success(preTrackTemEntrust);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            return failed(null,e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            return failed(null,"操作异常，请确认！");
        } finally {

        }
    }


    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的preTrackTemEntrust信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "preTrackTemEntrust", value = "详细实体preTrackTemEntrust", required = true, dataType = "PreTrackTemEntrust")
    })
    //@RequiresPermissions("pretracktementrust:update")
    @PutMapping(value = "/update", produces = "application/json;charset=UTF-8")
    public RESTfulResult updateInfo(@RequestBody PreTrackTemEntrust model) {
        try {
            model.setId(model.getEntrustNo());
            model.setUpdateTime(new Date());
            PreTrackTemEntrust preTrackTemEntrust = preTrackTemEntrustService.modify(model);
            return success(preTrackTemEntrust);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    /**
     * 查询接口
     *
     * @param modele
     * @return
     */
    //@RequiresPermissions("pretracktementrust:view")
    @PostMapping(value = "/doQuery")
    public RESTfulResult doQuery(@RequestBody CommonPage<PreTrackTemEntrust> modele) {
//        HashMap<String, Object> parmas = new HashMap<>();
        try {
            Map<String, Object> parmas = FieldsCollector.beanToMap(modele.getParam());

            PageList<PreTrackTemEntrust> list = preTrackTemEntrustService.queryLikeForPage(parmas, modele.getPageNum(), modele.getPageSize());
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }
}
